<template>
  <div id="teacher_class_index_wrapper" class="bt-container" style="display: flex; flex-direction: column;">
    <div style="display: flex; flex-direction: row;">
      <h2 class="page-title">{{ $t('HEADER.MANAGE_COURSE')}}</h2> 
      <div class="right-align-margin-bottom-15" style="display: flex; flex-direction: row;">
        <!-- 강사 등록 -->
        <el-button v-if="authType === 4" :class="$attachReactablePostfix('el-btn')" @click="onClick('permit_teacher');" style="margin-right:10px;">강사 등록</el-button>
        <el-dialog title="강사 등록" :visible.sync="permitTeacherVisible" width="50%" @close="dialogClose()">
          <el-form :model="teacher" style="width:90%;">
            <el-form-item label="이메일" :label-width="formLabelWidth" style="float: left; width:80%;">
              <el-input v-model="teacher.email" autoComplete="off"></el-input>
            </el-form-item>
            <el-form-item label="강습자 명" :label-width="formLabelWidth"  style="float: left; width:80%;">
              <el-input v-model="teacher.name" autoComplete="off"  style="width: 58%"></el-input>
              <el-button @click="checkTeacher(teacher)" style="width: 40%"> 유효성 체크 </el-button>
            </el-form-item>
          </el-form>
          <!-- 아랫부분 css 해결을 못했음. 상위 요소 css 상속하면서 생긴 문제 같은데 해결하지 못해서 임시로 아래처럼 해두었음. -->
          <!-- 화면 크기 따라 과목 개설 요청 dialog가 막 바뀜... -->
          <br /> <br />  <br />   <br />   <br /><br /> <br />  <br /> <br /><br /><br /><br /><br /> <br /> <br />
                  <br /> <br />  <br />   <br />   <br /><br /> <br />  <br /> <br />  <br /> <br />  <br />   <br />   
          <span slot="footer" class="dialog-footer">
            <el-button type="primary" @click="onClick('register')">{{ $t('TEACHER_CLASS.CONFIRM') }}</el-button>
            <el-button @click="onClick('cancel')">{{ $t('TEACHER_CLASS.CANCEL') }}</el-button>
          </span>
        </el-dialog>

        <!-- 강사 요청 현황 -->
        <el-button v-if="authType === 1" :class="$attachReactablePostfix('el-btn')" @click="onClick('request_status');" style="margin-right:10px;">{{ $t('TEACHER_CLASS.REQUEST_STATUS') }}</el-button>
        <el-dialog :title="$t('TEACHER_CLASS.REQUEST_STATUS')" :visible.sync="dialogStatusVisible" width="70%" @close="dialogClose()">
          <div style="height: 450px; overflow-y: scroll;">
            <el-table
              :data="result"
              style="width: 100%"
              >
              <el-table-column
                prop="index"
                label='#'
                width="50"
                align="center"
              >
                <template slot-scope="scope">
                  {{ scope.$index + 1 }}
                </template>
              </el-table-column>
              <el-table-column
                prop="affiliation_description.description"
                :label="$t('TEACHER_CLASS.AFFILIATION')"
                align="center">
              </el-table-column>
              <el-table-column
                prop="class_name"
                :label="$t('TEACHER_CLASS.CRS_NAME')"
                align="center">
              </el-table-column>
              <el-table-column
                prop="type_name"
                :label="$t('TEACHER_CLASS.TYPE')"
                width="120"
                align="center">
              </el-table-column>
              <el-table-column
                prop="status_name"
                :label="$t('ASSIGNMENT.CRR_STTS')"
                align="center"
                width="250">
              </el-table-column>
            </el-table>
            <br />
            <br />
            <el-button @click="dialogStatusVisible = false">{{ $t('TEACHER_CLASS.CONFIRM') }}</el-button>
          </div>
        </el-dialog>
        <!-- 주제 생성 요청 -->
        <el-button v-if="authType !== 4" :class="$attachReactablePostfix('el-btn')" @click="dialogFormVisible = true" style="margin-right:10px;">
          {{ $t('TEACHER_CLASS.REQUEST_NEW_COURSE') }}
        </el-button>
        <el-dialog :title="$t('TEACHER_CLASS.REQUEST_NEW_COURSE')" :visible.sync="dialogFormVisible" width="50%" >
          <el-form :model="form" style="width:80%;">
            <!-- <el-form-item :label="$t('TEACHER_CLASS.CRS_TYPE')" :label-width="formLabelWidth" style="float: left;">
              <el-radio v-model="selSubjectType" label="1">{{ $t('TEACHER_CLASS.SUBJ_TYPE_PRIVATE') }}</el-radio>
              <el-radio v-model="selSubjectType" label="2" @click="selSubjectType2()">{{ $t('TEACHER_CLASS.SUBJ_TYPE_PUBLIC') }}</el-radio>
            </el-form-item> -->
            <el-form-item :label="$t('TEACHER_CLASS.CRS_NAME')" :label-width="formLabelWidth"  style="float: left; width:80%;">
              <el-input v-model="form.name" autoComplete="off" ></el-input>
            </el-form-item>
            <el-form-item :label="$t('TEACHER_CLASS.TYPE')" :label-width="formLabelWidth" style="float: left; width:80%;">
              <el-select v-if="!isOpen" v-model="form.type" :placeholder="$t('TEACHER_CLASS.TYPE')" style="width:100%;">
                <el-option :label="$t('TEACHER_CLASS.TYPE_GENERAL')" value="1"></el-option>
                <!--<el-option :label="$t('TEACHER_CLASS.TYPE_STREAMING')" value="2"></el-option>-->
                <el-option :label="$t('TEACHER_CLASS.TYPE_PRACTICE')" value="3"></el-option>
                <el-option :label="$t('TEACHER_CLASS.TYPE_ETC')" value="4"></el-option>
              </el-select>
              <el-select v-if="isOpen" v-model="form.type" :placeholder="$t('TEACHER_CLASS.TYPE')" style="width:100%;">
                <el-option :label="$t('TEACHER_CLASS.TYPE_ETC')" value="4"></el-option>
              </el-select>
            </el-form-item>
            <el-form-item :label="$t('TEACHER_CLASS.SELECT_AFF')" :label-width="formLabelWidth" style="float: left;width:80%;">
              <el-select v-model='form.aff_id' :placeholder="$t('TEACHER_CLASS.SELECT_AFF_PLZ')" @change="selectAff($event)" style="width:100%;">
                <el-option v-for="item in affiliations"
                  :key="item.affiliation_description.affiliation_id" 
                  :label="item.affiliation_description.description" 
                  :value="item.affiliation_description.affiliation_id"></el-option>
              </el-select>
            </el-form-item>
            <el-form-item :label="$t('TEACHER_CLASS.EXPLAIN_COURSE')" :label-width="formLabelWidth" style="float: left;width:80%;">
              <el-input type="textarea" v-model="form.detail" :autosize="{ minRows: 10, maxRows: 10 }" ></el-input>
            </el-form-item>
          </el-form>
          <!-- 아랫부분 css 해결을 못했음. 상위 요소 css 상속하면서 생긴 문제 같은데 해결하지 못해서 임시로 아래처럼 해두었음. -->
          <!-- 화면 크기 따라 과목 개설 요청 dialog가 막 바뀜... -->
          <br /> <br />  <br />   <br />   <br /><br /> <br />  <br /> <br /><br /><br /><br /><br /> <br /> <br />
                  <br /> <br />  <br />   <br />   <br /><br /> <br />  <br /> <br />  <br /> <br />  <br />   <br />   
          <span slot="footer" class="dialog-footer">
            <el-button type="primary" @click="onClick('request')">{{ $t('TEACHER_CLASS.CONFIRM') }}</el-button>
            <el-button @click="onClick('cancel')">{{ $t('TEACHER_CLASS.CANCEL') }}</el-button>
          </span>
        </el-dialog>
        <!-- 주제 비밀번호 생성 -->
        <el-button v-if="authType === 4" :class="$attachReactablePostfix('el-btn')" @click="dialogPasswordVisible = true" style="margin-right:10px;">{{ $t('AFFILIATION_ADMIN.CRT_CLS_PW') }}</el-button>
        <el-dialog :title="$t('AFFILIATION_ADMIN.CRT_CLS_PW')" :visible.sync="dialogPasswordVisible" width="50%" @close="dialogClose()">
          <el-form :model="form" style="width:80%;">
            <!-- <el-form-item :label="$t('TEACHER_CLASS.CRS_TYPE')" :label-width="formLabelWidth" style="float: left;">
              <el-radio v-model="selSubjectType" label="1">{{ $t('TEACHER_CLASS.SUBJ_TYPE_PRIVATE') }}</el-radio>
              <el-radio v-model="selSubjectType" label="2">{{ $t('TEACHER_CLASS.SUBJ_TYPE_PUBLIC') }}</el-radio>
            </el-form-item> -->
            <el-form-item :label="$t('TEACHER_CLASS.CRS_NAME')" :label-width="formLabelWidth"  style="float: left; width:80%;">
              <el-input v-model="form.name" autoComplete="off" ></el-input>
            </el-form-item>
            <el-form-item :label="$t('TEACHER_CLASS.TYPE')" :label-width="formLabelWidth" style="float: left; width:80%;">
              <el-select v-model="form.type" :placeholder="$t('TEACHER_CLASS.TYPE')" style="width:100%;">
                <el-option v-if="selSubjectType === '1'" :label="$t('TEACHER_CLASS.TYPE_GENERAL')" value="1"></el-option>
                <!--<el-option v-if="selSubjectType === '1'" :label="$t('TEACHER_CLASS.TYPE_STREAMING')" value="2"></el-option>-->
                <el-option v-if="selSubjectType === '1'" :label="$t('TEACHER_CLASS.TYPE_PRACTICE')" value="3"></el-option>
                <el-option v-if="selSubjectType === '2'" :label="$t('TEACHER_CLASS.TYPE_ETC')" value="4"></el-option>
              </el-select>
            </el-form-item>
            <el-form-item :label="$t('TEACHER_CLASS.SELECT_AFF')" :label-width="formLabelWidth" style="float: left;width:80%;">
              <el-select v-model='form.aff_id' :placeholder="$t('TEACHER_CLASS.SELECT_AFF_PLZ')" @change="selectAff($event)" style="width:100%;">
                <el-option v-for="(item,index) in affiliations" 
                  :key="`${item.affiliation_description.affiliation_id}${index}`" 
                  :label="item.affiliation_description.description" 
                  :value="item.affiliation_description.affiliation_id"></el-option>
              </el-select>
            </el-form-item>
            <el-form-item :label="$t('TEACHER_CLASS.EXPLAIN_COURSE')" :label-width="formLabelWidth" style="float: left;width:80%;">
              <el-input type="textarea" v-model="form.detail" :autosize="{ minRows: 10, maxRows: 10 }" ></el-input>
            </el-form-item>
          </el-form>
          <!-- 아랫부분 css 해결을 못했음. 상위 요소 css 상속하면서 생긴 문제 같은데 해결하지 못해서 임시로 아래처럼 해두었음. -->
          <!-- 화면 크기 따라 과목 개설 요청 dialog가 막 바뀜... -->
          <br /> <br />  <br />   <br />   <br /><br /> <br />  <br /> <br /><br /><br /><br /><br /> <br /> <br />
                  <br /> <br />  <br />   <br />   <br /><br /> <br />  <br /> <br />  <br /> <br />  <br />   <br />   
          <span slot="footer" class="dialog-footer">
            <el-button type="primary" @click="onClick('CREATE_CLASS_PW')">{{ $t('TEACHER_CLASS.CONFIRM') }}</el-button>
            <el-button @click="onClick('cancel')">{{ $t('TEACHER_CLASS.CANCEL') }}</el-button>
          </span>
        </el-dialog>
        <!-- 주제 개설 -->
        <el-button
          :class="$attachReactablePostfix('el-btn')"
          @click="onClick('newCourse')"
          style="margin-right:10px;">
          {{ $t('TEACHER_CLASS.NEW_COURSE') }}
        </el-button>
        <!-- <router-link to="/a/teacher/NNclass/new">
          <el-button :class="$attachReactablePostfix('el-btn')" style="margin-right:10px;">{{ $t('TEACHER_CLASS.NEW_COURSE') }}</el-button>
        </router-link>   -->
        <!-- 뒤로 가기 -->
        <el-button :class="$attachReactablePostfix('el-btn')" size="small" @click="onClick('BACK')">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
      </div>
    </div>
    <el-dialog
      :visible.sync="newCourseVisible"
      :title="$t('TEACHER_CLASS.NEW_COURSE')"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      center>
      <teacher-class-new
        :key="`newCourseVisible${newCourseVisible}`"
        @finish="onClickFinish">
      </teacher-class-new>
    </el-dialog>
    <el-dialog
      :visible.sync="editCourseVisible"
      :title="$t('TEACHER_CLASS.EDIT_COURSE')"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      center>
      <teacher-class-new
        :editCourseData="editCourseData"
        :key="`editCourseVisible${editCourseVisible}`"
        @finish="onClickFinish"
      ></teacher-class-new>
    </el-dialog>
    <el-dialog
      :visible.sync="manageEnrollmentVisible"
      :title="$t('TEACHER_CLASS.MNG_ENROLL')"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      width="65%"
      center>
      <teacher-class-manage-enrollment
        :classId="manageEnrollmentData.class_id"
        :key="manageEnrollmentData.class_id">
      </teacher-class-manage-enrollment>
    </el-dialog>

    <div v-if="authType !== 4">
      <class-list-manage
        @delete="onClickDelete"
        @manage="onClickManage"
        @edit="onClickEdit"
        type="TEACHER"
        :list="teachingClassList || []"
        class="elTable-font"
        :isPhone="$isPhone"
      />
    </div>
    <div v-if="authType === 4">
      <el-tabs>
        <el-tab-pane label="주제 관리">
          <class-list-manage
            @delete="onClickDelete"
            @manage="onClickManage"
            @edit="onClickEdit"
            type="ADMIN"
            :list="affiliationClasses || []"
            class="elTable-font"
            :isPhone="$isPhone"
          />
        </el-tab-pane>
        <el-tab-pane label="주제 비밀번호 관리">
          <class-password-list-manage
            @delete="onClickDeletePassword"
            type="ADMIN"
            :list="classPasswordList || []"
            class="elTable-font"
            :isPhone="$isPhone"
          />
        </el-tab-pane>
      </el-tabs>
    </div>

    <br />
  </div>
</template>
<script>
import { mapState, mapMutations, mapActions } from "vuex";
import ClassListManage from "../partials/ClassListManage";
import classService from "../../services/classService";
import authService from "../../services/authService";
import utils from "../../utils";
import createClass from "../../services/createClass";
import classPasswordListManage from "../partials/ClassPasswordListManage";
import affiliationService from "../../services/affiliationService";
import userService from "../../services/userService";
import TeacherClassNew from "./NNTeacherClassNew";
import TeacherClassManageEnrollment from "./TeacherClassManageEnrollment";

export default {
  name: "TeacherClassIndex",
  async created() {
    const vm = this;
    // 학생이 url로 접근하는 경우 방지
    const accessId = utils.getUserIdFromJwt();
    // 클릭 로그 필요(아이디 확인)
    const accessCheck = await authService.returnUserInfo({
      userID: accessId,
    });
    if (accessCheck.data.userInfo.type === 0) {
      vm.$router.push({ name: "LandingPage" });
    }
    vm.form.user_id = accessId;
    //클릭 로그 필요(유저권한획득)
    const res2 = await createClass.getUserAffiliation({
      userId: vm.form.user_id,
    });
    res2.data.result.forEach((element) => {
      vm.affiliations.push(element);
    });
    // 클릭 로그 필요(주제 비빌번호 생성)
    const list = await createClass.getClassPassword();
    list.data.list.forEach(async (x) => {
      const tmp = {
        id: x.req_create_class.req_id,
        password: x.password,
        name: x.req_create_class.class_name,
        type: x.req_create_class.type,
        subjectType: x.req_create_class.subject_type,
      };
      //클릭 로그 필요(주제 비빌번호 확인)
      await vm.classPasswordList.push(tmp);
    });
  },
  components: {
    ClassListManage,
    classPasswordListManage,
    TeacherClassNew,
    TeacherClassManageEnrollment,
  },
  computed: {
    ...mapState("NNclass", ["teachingClassList"]),
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
  },
  data() {
    return {
      affiliationClasses: [],
      dialogFormVisible: false,

      dialogStatusVisible: false, //요청 현황 dialog
      // 제출 버튼 누를 때, 메소드 작동. 이 때 onClick 메소드 조정해서 form에
      form: {
        aff: undefined,
        aff_id: null,
        aff_name: undefined,
        type: null,
        user_id: null,
        name: "",
        detail: "",
      },
      teacher: {
        name: "",
        email: "",
        userId: "",
        checkFlag: false,
      },
      editCourseData: null,
      newCourseVisible: false,
      editCourseVisible: false,
      manageEnrollmentVisible: false,
      manageEnrollmentData: {
        class_id: 0,
      },
      checkList: [],
      result: [],
      affiliations: [],
      affiliation: [],
      formLabelWidth: "200px",
      selSubjectType: "1",
      dialogPasswordVisible: false,
      classPasswordList: [],
      isOpen: false,
      permitTeacherVisible: false,
    };
  },
  async beforeMount() {
    const vm = this;
    // body의 width가 window의 width와 불일치 하는 현상 처리
    document.body.style.width = `${window.innerWidth}px`;
    // 클릭 로그 필요(주제 목록)
    await vm.getMyClassLists();
    // 클릭 로그 필요
    const res1 = await classService.getAffiliationClassList();
    // res1.data.affiliateClasses.forEach((element) => {
    //   vm.affiliationClasses.push(element);
    // });

    vm.affiliationClasses = res1.data.affiliateClasses;
  },
  methods: {
    ...mapMutations("NNclass", ["deleteTeachingClass"]),
    ...mapActions("NNclass", ["getMyClassLists"]),
    dialogClose() {
      const vm = this;
      vm.dialogFormVisible = false;
      vm.dialogStatusVisible = false;
      vm.dialogPasswordVisible = false;
      vm.permitTeacherVisible = false;
      vm.manageEnrollmentVisible = false;
      vm.form.type = null;
      vm.form.name = null;
      vm.form.detail = null;
      vm.form.aff_id = null;
      vm.teacher.email = "";
      vm.teacher.name = "";
      vm.teacher.userId = "";
      vm.teacher.checkFlag = false;
      vm.editCourseVisible = false;
      vm.newCourseVisible = false;
    },
    async checkTeacher(form) {
      const vm = this;
      form.email = form.email.trim();
      form.name = form.name.trim();
      if (form.email === "") {
        vm.$notify({
          title: "오류",
          message: "이메일을 입력해주세요.",
          type: "error",
          duration: 3000,
        });
      } else if (form.name === "") {
        vm.$notify({
          title: "오류",
          message: "이름을 입력해주세요.",
          type: "error",
          duration: 3000,
        });
      } else {
        // 클릭 로그 필요(강사 이메일, 이름 확인)
        const res = await userService.searchUserByForm({
          email: form.email,
          name: form.name,
        });
        if (!res.data.success) {
          vm.$notify({
            title: "오류",
            message: "해당하는 강습자 계정이 없습니다.",
            type: "error",
            duration: 3000,
          });
          vm.teacher.userId = "";
        } else {
          vm.$notify({
            title: "성공",
            message: "해당하는 강습자 계정이 있습니다.",
            type: "success",
            duration: 3000,
          });
          vm.teacher.checkFlag = true;
          vm.teacher.userId = res.data.userCheck.user_id;
        }
      }
    },
    changeRequestStatus() {
      const vm = this;
      for (let i = 0; i < vm.checkList.length; i += 1) {
        switch (vm.checkList[i].type) {
          case 1:
            vm.checkList[i].type_name = vm.$t("TEACHER_CLASS.TYPE_GENERAL");
            break;
          case 2:
            vm.checkList[i].type_name = vm.$t("TEACHER_CLASS.TYPE_STREAMING");
            break;
          case 3:
            vm.checkList[i].type_name = vm.$t("TEACHER_CLASS.TYPE_PRACTICE");
            break;
          case 4:
            vm.checkList[i].type_name = vm.$t("TEACHER_CLASS.TYPE_ETC");
            break;
          default:
            break;
        }
        switch (vm.checkList[i].status) {
          case 0:
            vm.checkList[i].status_name = "대기";
            vm.result.push(vm.checkList[i]);
            break;
          case 1:
            vm.checkList[i].status_name = "승낙(생성 가능)";
            vm.result.push(vm.checkList[i]);
            break;
          case 2:
            vm.checkList[i].status_name = "거절";
            vm.result.push(vm.checkList[i]);
            break;
          case 3:
            //vm.checkList.splice(i,1);
            vm.checkList[i].status_name = "승낙(생성 완료)";
            break;
          default:
            break;
        }
      }
    },
    onClickManage(index) {
      const vm = this;
      if (vm.authType === 1) {
        vm.manageEnrollmentData = vm.teachingClassList[index];
      } else {
        vm.manageEnrollmentData = vm.affiliationClasses[index];
      }
      vm.manageEnrollmentVisible = true;
    },
    onClickEdit(index) {
      const vm = this;
      if (vm.authType === 1) {
        vm.editCourseData = vm.teachingClassList[index];
      } else if (vm.authType === 4) {
        vm.editCourseData = vm.affiliationClasses[index];
      }
      vm.editCourseVisible = true;
    },
    async refreshLists() {
      const vm = this;

      await vm.getMyClassLists();
      const res1 = await classService.getAffiliationClassList();
      vm.affiliationClasses = res1.data.affiliateClasses;
    },
    async onClickFinish() {
      const vm = this;
      await vm.refreshLists();
      vm.dialogClose();
    },
    onClickDelete(index) {
      const vm = this;

      let currentTeachingClass;
      if (vm.authType === 1) {
        currentTeachingClass = vm.teachingClassList[index];
      } else if (vm.authType === 4) {
        currentTeachingClass = vm.affiliationClasses[index];
      }
      vm.$confirm(
        vm.$t("TEACHER_CLASS.DELETE_CLASS_QUES", {
          name: currentTeachingClass.name || "",
        }),
        vm.$t("TEACHER_CLASS.DELETE_CLASS_NAME", {
          name: currentTeachingClass.name || "",
        }),
        {
          confirmButtonText: vm.$t("TEACHER_CLASS.YES"),
          cancelButtonText: vm.$t("TEACHER_CLASS.NO"),
          type: "warning",
        }
      )
        .then(async () => {
          // await classService.delete({
          //   id: currentClass.class_id,
          // });
          // 클릭로그 필요 (주제 삭제 버튼)
          await classService.putClassToHide({
            id: currentTeachingClass.class_id,
          });
          vm.$notify({
            title: vm.$t("TEACHER_CLASS.DELETE_COURSE"),
            message: vm.$t("TEACHER_CLASS.DELETE_COURSE_SUC"),
            type: "success",
            duration: 3000,
          });
          vm.refreshLists();
        })
        .catch(() => {
          vm.$notify({
            title: vm.$t("TEACHER_CLASS.DELETE_COURSE"),
            message: vm.$t("NOTIFY.SUBJ_DEL_CANC"),
            type: "info",
            duration: 3000,
          });
        });
    },
    async onClickDeletePassword(index) {
      const vm = this;
      // 클릭 로그 필요(주제 비빌번호 삭제)
      const res = await createClass.deleteClassPassword({
        id: vm.classPasswordList[index].id,
      });
      vm.classPasswordList.splice(index, 1);
    },
    async genPassword() {
      const vm = this;
      const rand = new Array(16).join().replace(/(.|$)/g, function () {
        return ((Math.random() * 16) | 0).toString(16);
      });
      // 클릭 로그 필요(주제 비빌번호 설정)
      const exist = await createClass.getClassPasswordByPassword({
        pwd: rand,
      });
      if (exist.data.class_password !== null) {
        vm.genPassword();
      } else {
        return rand;
      }
    },
    async onClick(type) {
      const vm = this;
      switch (type) {
        case "BACK": {
          location.href = "javascript:history.back();";
          break;
        }
        case "newCourse": {
          vm.newCourseVisible = true;
          break;
        }
        case "request": {
          if (vm.form.name === null || vm.form.name === "") {
            vm.$notify({
              title: vm.$t("DASHBOARD.AALERT"),
              message: vm.$t("TEACHER_CLASS.CRS_NAME_PLZ"),
              type: "warning",
            });
            break;
          }
          if (vm.form.type === null) {
            vm.$notify({
              title: vm.$t("DASHBOARD.AALERT"),
              message: vm.$t("TEACHER_CLASS.SELECT_TYPE_PLZ"),
              type: "warning",
            });
            break;
          }
          if (vm.form.aff_id === null) {
            vm.$notify({
              title: vm.$t("DASHBOARD.AALERT"),
              message: vm.$t("TEACHER_CLASS.SELECT_AFF_PLZ"),
              type: "warning",
            });
            break;
          }
          if (
            vm.form.aff_id !== null &&
            vm.form.name !== null &&
            vm.form.name !== "" &&
            vm.form.type !== null
          ) {
            vm.dialogFormVisible = false;
            //클릭 로그 필요(주제 내용)
            await createClass.requestClass({
              subjectType: vm.selSubjectType,
              affiliationId: vm.form.aff_id,
              class_type: vm.form.type,
              className: vm.form.name,
              class_detail: vm.form.detail,
            });
            vm.form.type = null;
            vm.form.name = null;
            vm.form.detail = null;
            vm.form.aff_id = null;
            vm.$notify({
              title: vm.$t("NOTIFY.TITLE"),
              message: vm.$t("TEACHER_CLASS.REQ_CONFIRM"),
              type: "success",
            });
          }
          break;
        }
        case "request_status": {
          vm.dialogStatusVisible = true;
          //클릭 로그 필요(주제 요청 상황)
          const res = await createClass.searchaRequestStatus({
            userId: vm.form.user_id,
          });
          vm.checkList = res.data.result;
          vm.result = [];
          vm.changeRequestStatus();
          break;
        }
        case "permit_teacher": {
          vm.permitTeacherVisible = true;
          break;
        }
        case "cancel": {
          vm.dialogFormVisible = false;
          vm.dialogStatusVisible = false;
          vm.dialogPasswordVisible = false;
          vm.permitTeacherVisible = false;
          vm.form.type = null;
          vm.form.name = null;
          vm.form.detail = null;
          vm.form.aff_id = null;
          vm.teacher.email = "";
          vm.teacher.name = "";
          vm.teacher.userId = "";
          break;
        }
        case "register": {
          const vm = this;
          if (vm.teacher.checkFlag) {
            // 클릭 로그 필요(강사 권리 확인)
            const res = await userService.postTeacherBelongingByAdmin({
              userId: vm.teacher.userId,
            });
          } else {
            vm.$notify({
              title: "오류",
              message: "유효성 체크를 부탁드립니다.",
              type: "warning",
            });
          }
          vm.permitTeacherVisible = false;
          vm.teacher.email = "";
          vm.teacher.name = "";
          vm.teacher.checkFlag = false;
          vm.teacher.userId = "";
          break;
        }
        case "CREATE_CLASS_PW": {
          if (vm.form.name === null || vm.form.name === "") {
            vm.$notify({
              title: vm.$t("DASHBOARD.AALERT"),
              message: vm.$t("TEACHER_CLASS.CRS_NAME_PLZ"),
              type: "warning",
            });
            break;
          }
          if (vm.form.type === null) {
            vm.$notify({
              title: vm.$t("DASHBOARD.AALERT"),
              message: vm.$t("TEACHER_CLASS.SELECT_TYPE_PLZ"),
              type: "warning",
            });
            break;
          }
          if (vm.form.aff_id === null) {
            vm.$notify({
              title: vm.$t("DASHBOARD.AALERT"),
              message: vm.$t("TEACHER_CLASS.SELECT_AFF_PLZ"),
              type: "warning",
            });
            break;
          }
          // 클릭 로그 필요(요청 주제 내용)
          const res = await createClass.postRequestClass({
            subjectType: vm.selSubjectType,
            affiliationId: vm.form.aff_id,
            class_type: vm.form.type,
            className: vm.form.name,
            class_detail: vm.form.detail,
          });
          //클릭 로그 필요(주제 비빌번호 설정)
          const passwd = await vm.genPassword();
          //클릭 로그 필요(관리자가 주제 비빌번호 설정)
          const res2 = await createClass.createClassPasswordByAdmin({
            password: passwd,
            req_id: res.data.result.req_id,
          });
          vm.$notify({
            title: vm.$t("NOTIFY.TITLE"),
            message: vm.$t("TEACHER_CLASS.REQ_CONFIRM"),
            type: "success",
          });
          const tmp = {
            id: res2.data.class_pw.req_id,
            password: res2.data.class_pw.password,
            name: vm.form.name,
            type: vm.form.type,
            subjectType: vm.selSubjectType,
          };
          vm.classPasswordList.push(tmp);
          vm.dialogPasswordVisible = false;
          vm.form.type = null;
          vm.form.name = null;
          vm.form.detail = null;
          vm.form.aff_id = null;
          break;
        }
        default: {
          throw new Error("unexpected type: ", type);
        }
      }
    },
    async searchStatus() {
      const vm = this;
      //클릭 로그 필요(요청된 주제 정보)
      vm.data.checkList = await createClass.searchaRequestStatus({
        userId: vm.form.user_id,
      });
    },
    async searchAffId() {
      const vm = this;
      // 클릭 로그 필요(아이디 검색)
      const aff_id = await createClass.searchAffId({
        userId: vm.form.user_id,
      });
      aff_id.data.result.forEach((x) => {
        const info = {};
        info.aff_name = x.description;
        info.aff_id = x.affiliation_id;
        vm.affiliations.push(info);
      });
    },
    async selectAff(e) {
      const vm = this;
      // 클릭 로그 필요(정보)
      const res = await affiliationService.getAffiliationInfo({
        affiliationId: e,
      });
      if (res.data.affiliation.isOpen === 0) {
        vm.isOpen = 0;
      } else {
        vm.isOpen = 1;
      }

      vm.form.aff_id = e;
    },
  },
};
</script>
<style lang="scss" scoped>
#teacher_class_index_wrapper {
  .page-title {
    float: left;
    width: 100%;

    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top: 40px;
    margin-left: 12px;
    margin-bottom: 25px;
  }
  .right-align {
    text-align: right;
  }

  .right-align-btn {
    width: 100%;
    height: 40px;
    border-radius: 3px;
    border: solid 1px #1989fa;
  }
  .right-align-btn-layer {
    width: 94px;
    height: 12px;
    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #ffffff;
    margin-left: auto;
    margin-right: auto;
  }
  .el-table th {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }

  .el-table td {
    font-family: SpoqaHanSans;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #1989fa;
  }
  .right-align-btn-phone {
    display: none;
  }

  .right-align-margin-bottom-15 {
    float: right;
    display: block;
    text-align: center;
    margin-top: 40px;
    margin-bottom: 25px;
  }

  .el-btn {
    width: 140px;
    height: 40px;
    border-radius: 3px;
    background-color: #ffffff;
    border: solid 1px #1989fa;
    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #1989fa;
  }

  .el-table .warning-row {
    background: #f5a9a9;
  }
  .el-table .success-row {
    background: #cef6ce;
  }
  #table_design {
    border-collapse: collapse;
    text-align: center;
    line-height: 1.5;
    border-top: 1px solid #321;
    border-bottom: 1px solid #321;
    border-block-end: 1px solid #321;
    margin: 20px 10px;
  }
  #table_design thead {
    width: 350px;
    padding: 10px;
    vertical-align: top;
    color: #111;
    background: rgb(160, 213, 250);
    margin: 20px 10px;
  }
  #table_design td {
    width: 350px;
    padding: 10px;
    font-size: 15px;
    color: #333;
  }
  #table_design tbody {
    border-bottom: 1px solid #321;
  }
}
</style>
